image: java:jdk-alpine

stages:
  - build
  - test
  - package

variables:
  GRADLE_OPTS: "-Dorg.gradle.daemon=false"
  GRADLE_USER_HOME: ".gradle_user_home"

cache:
  key: "$CI_COMMIT_REF_SLUG"
  paths:
    - $GRADLE_USER_HOME/wrapper
    - $GRADLE_USER_HOME/caches

build:
  stage: build
  script:
    - ./gradlew clean compileJava javadoc
  tags:
    - docker
  artifacts:
    paths:
    - .gradle
    - build/classes
    - build/docs/javadoc

test_project:
  stage: test
  script:
    - ./gradlew test
  tags:
    - docker
  dependencies:
    - build
  artifacts:
    when: always
    paths:
    - build/reports/tests
    - build/test-results

package:
  stage: package
  script:
    - ./gradlew bootJar
  tags:
    - docker
  dependencies:
    - build
  artifacts:
    when: always
    paths:
    - build/libs
